'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AtomTextareaSizes = undefined;

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BASE_CLASS = 'sui-AtomTextarea';
var SIZES = {
  SHORT: 'short',
  LONG: 'long'
};

var AtomTextarea = function (_Component) {
  (0, _inherits3.default)(AtomTextarea, _Component);

  function AtomTextarea() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, AtomTextarea);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = AtomTextarea.__proto__ || (0, _getPrototypeOf2.default)(AtomTextarea)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      value: _this.props.children // eslint-disable-line react/prop-types
    }, _this.handleChange = function (ev) {
      var value = ev.target.value;
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          maxCharacters = _this$props.maxCharacters; // eslint-disable-line react/prop-types

      if (value.length > maxCharacters) return;
      _this.setState({ value: value }, function () {
        return onChange && onChange({ value: value, ev: ev });
      });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(AtomTextarea, [{
    key: 'getClassNames',
    value: function getClassNames(size) {
      return (0, _classnames2.default)(BASE_CLASS, BASE_CLASS + '--' + size);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          onChange = _props.onChange,
          maxCharacters = _props.maxCharacters,
          size = _props.size,
          props = (0, _objectWithoutProperties3.default)(_props, ['onChange', 'maxCharacters', 'size']);

      return _react2.default.createElement('textarea', (0, _extends3.default)({}, props, {
        onChange: this.handleChange,
        className: this.getClassNames(size),
        value: this.state.value
      }));
    }
  }]);
  return AtomTextarea;
}(_react.Component);

AtomTextarea.displayName = 'AtomTextarea';

AtomTextarea.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? {
  /** Size of button: 'short', 'long' */
  size: _propTypes2.default.oneOf((0, _values2.default)(SIZES)),

  /** Maximum number of characters allowed  */
  maxCharacters: _propTypes2.default.number
} : {} : {};

AtomTextarea.defaultProps = {
  size: SIZES.SHORT,
  maxCharacters: 4000
};

exports.default = AtomTextarea;
exports.AtomTextareaSizes = SIZES;